import QtQuick 2.4

FocusScope {
    id: root
    property string rootObjectName: "popupRootElement"

    function findRootItem(objectName) {
        var next = this;
        while (next && next.parent) {
            next = next.parent;
            if (objectName === next.objectName)
                break;
        }
        return next;
    }

    function open() {
        if (d.isOpen)
            return;
        d.originalParent = parent;
        parent = findRootItem(rootObjectName);
        d.isOpen = true;
    }

    function close() {
        if (!d.isOpen)
            return;
        parent = d.originalParent;
        d.isOpen = false;
    }

    z: 10000
    visible: d.isOpen
    state: "closed"

    QtObject {
        id: d
        property QtObject originalParent: null
        property bool isOpen: false
    }

    states: [
        State {
            name: "open"
        },
        State {
            name: "closed"
        }
    ]
    transitions: [
        Transition {
            from: "closed"
            to: "open"
            reversible: true
            SequentialAnimation {
                ScriptAction {
                    script: root.close();
                }
                ScriptAction {
                    script: root.open();
                }
            }
        }
    ]
}
